//------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrSandyBrown
#property indicator_color3  clrSilver
#property indicator_color4  clrSilver
#property indicator_width3  2
#property indicator_width4  2
#property strict

//
//
//
//
//

extern int                period     = 14;          // Calculating period
extern ENUM_APPLIED_PRICE price      = PRICE_CLOSE; // Price
extern int                aperiod    = 14;          // Average period
extern ENUM_MA_METHOD     amethod    = MODE_EMA;    // Average method

double bufferu[];
double bufferuh[];
double bufferd[];
double bufferdd[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,bufferuh,INDICATOR_DATA); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,bufferdd,INDICATOR_DATA); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,bufferu ,INDICATOR_DATA);
   SetIndexBuffer(3,bufferd ,INDICATOR_DATA);
   IndicatorShortName("momentum trend ("+(string)period+","+(string)aperiod+")");
   return(0);
}

//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-2);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      bufferu[i] =  iRsi(iMA(NULL,0,aperiod,0,amethod,price,i),period,i,false); bufferuh[i] = bufferu[i];
      bufferd[i] = -iRsi(iMA(NULL,0,aperiod,0,amethod,price,i),period,i,true);  bufferdd[i] = bufferd[i];
      
   }      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//
//

double workRsi[][1];
#define _price  0

double iRsi(double rprice, double rperiod, int i, bool returnDn=false, int instanceNo=0)
{
   if (ArrayRange(workRsi,0)!=Bars) ArrayResize(workRsi,Bars); i = Bars-i-1;
   
   //
   //
   //
   //
   //
   
   workRsi[i][instanceNo+_price] = rprice;
      double avgUp=0,avgDn=0,up=0,dn=0;
         for(int k=0; k<rperiod && (i-k-1)>=0; k++)
         {
            double diff = workRsi[i-k][instanceNo+_price]- workRsi[i-k-1][instanceNo+_price];
            if(diff>0) { avgUp += diff; up++; }
            if(diff<0) { avgDn -= diff; dn++; }
         }
         if (up!=0) avgUp /= up;
         if (dn!=0) avgDn /= dn;
         if (returnDn)
               return(avgDn);
         else  return(avgUp);     
}
